#include <cstdio>
#include <algorithm>
#include <cstdarg>

using std::printf;

template<unsigned Size, typename T>
void elemlist<Size,T>::crop(bool cruel)
{
Retry:
    for(typename listtype::iterator a = elems.begin(); a != elems.end(); ++a)
    {
        elemlist tmp(*a);
        tmp.expand();
        /* Jos saa tmp:n toiminnot aikaan ilmankin tmp:t, poistetaan tmp */
        if(achieves(tmp, a, cruel))
        {
#ifdef ELEMLIST_DEBUG
            printf("# Deleting redundant: "); a->dump(); printf("\n");
#endif
            elems.erase(a);
            goto Retry;
        }
    }
}

template<unsigned Size, typename T>
void elemlist<Size,T>::expand()
{
    listtype result;
    
    for(typename listtype::const_iterator a = elems.begin(); a != elems.end(); ++a)
    {
        typename Elem::listtype::const_iterator ind[Size];
        for(unsigned b=0; b<Size; ++b)
        {
            ind[b] = a->begin(b); if(ind[b] == a->end(b))goto Next;
        }
        for(;;)
        {
            Elem tmp;
            for(unsigned c=0; c<Size; ++c)
                tmp.insert(c, *(ind[c]));
            result.push_back(tmp);
            unsigned b = 0;
        Re:
            if(++ind[b] != a->end(b))continue;
            ind[b] = a->begin(b);
            if(++b==Size)break; goto Re;
        }
    Next: ;
    }
    elems.swap(result);
}

template<unsigned Size, typename T>
void elemlist<Size,T>::combine()
{
    for(unsigned nc=0; nc<Size; ++nc)
    {
        for(typename listtype::iterator a = elems.begin(); a != elems.end(); ++a)
        {
        Retry:
            for(typename listtype::iterator b=a; ++b != elems.end(); )
            {
                if(Size == 3)
                {
                    for(unsigned d=0; d<Size; ++d)
                        if(a->iscommon(*b, d) != (d!=(nc+1)%Size))
                            goto Nope;
                    /* This nc thing is a little hack to priorize the
                     * way of combining the actions. For irc things, the
                     * most important thing is channels, then actions,
                     * and the least important grouping is the agents.
                     */
                }
                else
                {
                    unsigned commoncount = 0;
                    for(unsigned d=0; d<Size; ++d)
                        if(a->iscommon(*b, d))
                            ++commoncount;
                    if(commoncount != Size-1)goto Nope;
                }
                
    #ifdef ELEMLIST_DEBUG
                printf("# Combining "); b->dump();
                printf(" to "); a->dump();
    #endif
                a->combine(*b);
    #ifdef ELEMLIST_DEBUG
                printf(" as "); a->dump();
                printf("\n");
    #endif
                elems.erase(b);
                goto Retry;
            Nope: ;
            }
        }
        if(nc == 0 && Size != 3)break;
    }
}

template<unsigned Size, typename T>
void elemlist<Size,T>::join()
{
    /* Tm poistaa ylimrisi valintoja laittamalla toistensa plle niit.
     *
     * Esimerkki:
     *    CE*G  + BCD*HI + E*I
     * -> CE*GI + BCD*HI
     *
     * Menetelm: E*I:st kaikki paitsi yksi elementti sisltyy CE*G:hen.
     *            Siisp katsotaan voidaanko *I list CE*G:hen.
     *            Tt varten muodostetaan lista CE*GI:st ja katsotaan
     *            mahtuvatko kaikki mainitut elementit alkuperiseen listaan.
     *
     */
Retry:
    crop(false);
    
    for(typename listtype::iterator a = elems.begin(); a != elems.end(); ++a)
    {
        for(typename listtype::iterator b = elems.begin(); b != elems.end(); ++b)if(b != a)
        {
            Elem tmp2 = *b, tmp = tmp2.difference(*a);
            tmp2.combine(*a);
            elemlist comb(tmp2);
#ifdef ELEMLIST_DEBUG
            printf("# Testing if could achieve "); comb.dump(); printf("\n");
#endif
            comb.expand();
            
            if(achieves(comb, false))
            {
#ifdef ELEMLIST_DEBUG
                printf("# Joining "); b->dump();
                printf(" to "); a->dump();
                printf(" as "); tmp2.dump(); printf("\n");
#endif
                *a = tmp2;
                elems.erase(b);
                goto Retry;
            }
        }
    }
}

template<unsigned Size, typename T>
void elemlist<Size,T>::inflate()
{
    /* Tm laajentaa valinnat menemn toistensa plle. */
    for(typename listtype::iterator a = elems.begin(); a != elems.end(); ++a)
    {
        //for(typename listtype::const_iterator b = elems.begin(); b != elems.end(); ++b)if(b!=a)
        for(typename listtype::const_iterator b = a; ++b != elems.end(); )
        {
            bool same[Size]; unsigned samecount = 0;
            for(unsigned c=0; c<Size; ++c)
            {
                same[c] = b->contains(*a, c);
                if(Size==3 && c==0)same[c]=true;
                if(same[c])++samecount;
            }
            /*
            if(samecount == Size)
            {
#ifdef ELEMLIST_DEBUG
                printf("# Combining "); a->dump(); printf(" from "); b->dump(); printf("\n");
#endif
                a->combine(*b);
            }
            else */if(samecount == Size-1)
            {
                unsigned lack=0;
                for(unsigned c=0; c<Size; ++c)if(!same[c]){lack=c;break;}
                if(lack == 0 || Size != 3)
                {
#ifdef ELEMLIST_DEBUG
                    printf("# Combining "); a->dump(); printf(" from "); b->dump(); printf("\n");
#endif
                    a->combine(*b, lack);
                }
            }
        }
    }
}

template<unsigned Size, typename T>
template<class L3MAP>
void elemlist<Size,T>::expand3(const L3MAP &max3test)
{
    if(Size == 3)
    {
        listtype result;
        for(typename listtype::const_iterator a = elems.begin(); a != elems.end(); ++a)
        {
            Elem malli;
            malli.copy(*a, 0);
            malli.copy(*a, 1);
            
            std::list<Elem> stacks;
            
            typedef typename Elem::listtype::const_iterator eit;
            typedef typename std::list<Elem>::iterator sit;
            
            for(eit i = a->begin(2); i != a->end(2); ++i)
            {
                for(sit j = stacks.begin(); j != stacks.end(); ++j)
                    if(max3test.compatible(*i, *(j->begin(2))))
                    {
                        j->insert(2, *i);
                        goto stackskip;
                    }
                
                {Elem tmp = malli;
                tmp.insert(2, *i);
                stacks.push_back(tmp);}
                
            stackskip: ;
            }
            
            for(sit j = stacks.begin(); j != stacks.end(); ++j)
            {
#ifdef ELEMLIST_DEBUG
                printf("# Stack: "); j->dump(); printf("\n");
#endif
                for(eit i = j->begin(2); i != j->end(2); )
                {
                    Elem tmp;
                    tmp.copy(*j, 0);
                    tmp.copy(*j, 1);
                    unsigned c=0;
                    for(;;)
                    {
                        tmp.insert(2, *i);
                        if(max3test.needsparm(*i))++c;
                        ++i;
                        if((TestGroupCount && c >= max3test.groupcount()) || i == j->end(2))break;
                    }
#ifdef ELEMLIST_DEBUG
                    printf("# Adding "); tmp.dump(); printf(" (c=%u)\n", c);
#endif
                    result.push_back(tmp);
                }
            }
#ifdef ELEMLIST_DEBUG
            printf("# End of stacks\n");
#endif
        }
        elems.swap(result);
    }
}

template<unsigned Size, typename T>
bool elemlist<Size,T>::achieves(const elemlist &b, bool cruel) const
{
    for(typename listtype::const_iterator a = b.elems.begin(); a != b.elems.end(); ++a)
    {
        for(typename listtype::const_iterator c = elems.begin(); c != elems.end(); ++c)
            if(c->contains(*a, cruel))goto Ok;
        return false;
    Ok: ;
    }
    return true;
}

template<unsigned Size, typename T>
bool elemlist<Size,T>::achieves(const elemlist &b, typename listtype::const_iterator without, bool cruel) const
{
    for(typename listtype::const_iterator a = b.elems.begin(); a != b.elems.end(); ++a)
    {
        for(typename listtype::const_iterator c = elems.begin(); c != elems.end(); ++c)
        {
            if(c == without)continue;
            if(c->contains(*a, cruel))goto Ok;
        }
        return false;
    Ok: ;
    }
    return true;
}

#ifdef ELEMLIST_DEBUG
template<unsigned Size, typename T>
void elemlist<Size,T>::dump() const
{
    typename listtype::const_iterator i = elems.begin();
    if(i != elems.end()) for(;;)
    {
        i->dump();
        if(++i == elems.end())break;
        printf(" + ");
    }
}
#endif

template<unsigned Size, typename T>
void elemlist<Size,T>::Elem::addplot(T coord, ...)
{
    va_list ap;
    va_start(ap, coord);
    for(unsigned a=0; a<Size; ++a)
    {
        if(a)coord = va_arg(ap, T);
        insert(a, coord);
    }
    va_end(ap);
}

template<unsigned Size, typename T>
void elemlist<Size,T>::Elem::insert(unsigned ind, T elem)
{
    elems[ind].insert(elem);
}

template<unsigned Size, typename T>
const elemlist<Size,T>::Elem elemlist<Size,T>::Elem::difference(const Elem &b) const
{
    Elem tmp;
    
    for(unsigned a=0; a<Size; ++a)
    {
        //set_difference(begin(a), begin(a),
        //               b.begin(a), b.end(a),
        //               tmp.begin(a));
        
        typename listtype::const_iterator i;
        
        for(i=begin(a); i!=end(a); ++i)
            if(b.elems[a].find(*i) == b.end(a)) tmp.insert(a, *i);
        
        //for(i=b.begin(a); i!=b.end(a); ++i)
        //    if(elems[a].find(*i) == end(a)) tmp.insert(a, *i);
    }
    return tmp;
}

template<unsigned Size, typename T>
bool elemlist<Size,T>::Elem::contains(const Elem &b, unsigned ind) const
{
    return includes(
        begin(ind), end(ind), 
        b.begin(ind), b.end(ind)
      );
}

template<unsigned Size, typename T>
bool elemlist<Size,T>::Elem::contains(const Elem &b, bool mayopt) const
{
    for(unsigned ind=(Size==3 && mayopt)?1:0; ind<Size; ++ind)
        if(!contains(b, ind))return false;
    return true;
}

template<unsigned Size, typename T>
void elemlist<Size,T>::Elem::combine(const Elem &b)
{
    for(unsigned ind=0; ind<Size; ++ind)
        combine(b, ind);
}

template<unsigned Size, typename T>
void elemlist<Size,T>::Elem::combine(const Elem &b, unsigned ind)
{
    typename listtype::const_iterator i;
    for(i=b.begin(ind); i!=b.end(ind); ++i)
        if(elems[ind].find(*i) == end(ind))
            insert(ind, *i);
}

#ifdef ELEMLIST_DEBUG
template<unsigned Size, typename T>
void elemlist<Size,T>::Elem::dump() const
{
    for(unsigned a=0; a<Size; ++a)
    {
        if(a)printf("*");
        typename listtype::const_iterator i;
        for(i=begin(a); i!=end(a); ++i)
            printf("%c", *i);
    }
}
#endif

template<unsigned Size, typename T>
bool elemlist<Size,T>::Elem::iscommon(const Elem &b, unsigned ind) const
{
    return elems[ind] == b.elems[ind];
}

template<unsigned Size, typename T>
void elemlist<Size,T>::Elem::copy(const Elem &b, unsigned ind)
{
    elems[ind] = b.elems[ind];
}

template<unsigned Size, typename T>
template<class fmtfunc>
void elemlist<Size,T>::format(fmtfunc &formatter) const
{
    if(Size == 3)
    {
        for(typename listtype::const_iterator a = elems.begin(); a != elems.end(); ++a)
            formatter(
              a->begin(0), a->end(0),
              a->begin(1), a->end(1),
              a->begin(2), a->end(2));
    }
}
